Updating Openhab 3 Version blw. 3.0.2 via upgrade fails with errors (reaching 93.93.128.193)

Hello,
I am running an Openhab on a Raspberry Pi using openhabian in Version 3.0.0 Release Build.
When trying to upgrade the system via openhabian-config I receive the following errors, which seems mainly beeing caused by errors reaching IP Adress 93.93.128.193. But I can ping the adress:

2021-12-31_12:29:48_CET [openHABian] Updating repositories and upgrading installed packages...
Reading package lists... Done
Building dependency tree
Reading state information... Done
Calculating upgrade... Done
The following packages have been kept back:
  adoptopenjdk-11-hotspot-jre
The following packages will be upgraded:
  alsa-utils apt apt-transport-https apt-utils avahi-autoipd avahi-daemon base-files bind9-host bluez bluez-firmware ca-certificates curl
  device-tree-compiler file firmware-atheros firmware-brcm80211 firmware-libertas firmware-misc-nonfree firmware-realtek groff-base iproute2 iputils-ping
  isc-dhcp-client isc-dhcp-common klibc-utils libapt-inst2.0 libapt-pkg5.0 libasound2 libasound2-data libavahi-client3 libavahi-common-data libavahi-common3
  libavahi-core7 libbind9-161 libbsd0 libc-bin libc-dev-bin libc-l10n libc6 libc6-dbg libc6-dev libcurl3-gnutls libcurl4 libdns-export1104 libdns1104
  libgcrypt20 libgnutls30 libgssapi-krb5-2 libhogweed4 libisc-export1100 libisc1100 libisccc161 libisccfg163 libk5crypto3 libklibc libkrb5-3 libkrb5support0
  libldap-2.4-2 libldap-common libldb1 liblwres161 liblz4-1 libmagic-mgc libmagic1 libnettle6 libnftnl11 libp11-kit0 libpam-systemd libpolkit-agent-1-0
  libpolkit-backend-1-0 libpolkit-gobject-1-0 libpython3.7 libpython3.7-dev libpython3.7-minimal libpython3.7-stdlib libraspberrypi-bin libraspberrypi-dev
  libraspberrypi-doc libraspberrypi0 libssl1.1 libsystemd0 libudev1 libuv1 libx11-6 libx11-data libxml2 libzstd1 linux-libc-dev locales multiarch-support
  nodejs openhab openhab-addons openssh-client openssh-server openssh-sftp-server openssl pi-bluetooth policykit-1 python-dnspython python-ldb
  python-rpi.gpio python3.7 python3.7-dev python3.7-minimal raspberrypi-bootloader raspberrypi-kernel raspberrypi-net-mods raspberrypi-sys-mods rpi-eeprom
  rpi-update rpi.gpio-common screen ssh sudo systemd systemd-sysv tzdata udev unzip wpasupplicant
121 upgraded, 0 newly installed, 0 to remove and 1 not upgraded.
Need to get 301 MB/552 MB of archives.
After this operation, 11.3 MB of additional disk space will be used.
Err:1 http://raspbian.raspberrypi.org/raspbian buster/main armhf base-files armhf 10.3+rpi1+deb10u10
  404  Not Found [IP: 93.93.128.193 80]
Err:2 http://raspbian.raspberrypi.org/raspbian buster/main armhf libgssapi-krb5-2 armhf 1.17-3+deb10u2
  404  Not Found [IP: 93.93.128.193 80]
Err:3 http://raspbian.raspberrypi.org/raspbian buster/main armhf libkrb5-3 armhf 1.17-3+deb10u2
  404  Not Found [IP: 93.93.128.193 80]
Err:4 http://raspbian.raspberrypi.org/raspbian buster/main armhf libkrb5support0 armhf 1.17-3+deb10u2
  404  Not Found [IP: 93.93.128.193 80]
Err:5 http://raspbian.raspberrypi.org/raspbian buster/main armhf libk5crypto3 armhf 1.17-3+deb10u2
  404  Not Found [IP: 93.93.128.193 80]
Err:6 http://raspbian.raspberrypi.org/raspbian buster/main armhf tzdata all 2021a-0+deb10u1
  404  Not Found [IP: 93.93.128.193 80]
Err:7 http://raspbian.raspberrypi.org/raspbian buster/main armhf libisc-export1100 armhf 1:9.11.5.P4+dfsg-5.1+deb10u5
  404  Not Found [IP: 93.93.128.193 80]
Err:8 http://raspbian.raspberrypi.org/raspbian buster/main armhf libdns-export1104 armhf 1:9.11.5.P4+dfsg-5.1+deb10u5
  404  Not Found [IP: 93.93.128.193 80]
Err:9 http://raspbian.raspberrypi.org/raspbian buster/main armhf bind9-host armhf 1:9.11.5.P4+dfsg-5.1+deb10u5
  404  Not Found [IP: 93.93.128.193 80]
Err:10 http://raspbian.raspberrypi.org/raspbian buster/main armhf libbind9-161 armhf 1:9.11.5.P4+dfsg-5.1+deb10u5
  404  Not Found [IP: 93.93.128.193 80]
Err:11 http://raspbian.raspberrypi.org/raspbian buster/main armhf libisccfg163 armhf 1:9.11.5.P4+dfsg-5.1+deb10u5
  404  Not Found [IP: 93.93.128.193 80]
Err:12 http://raspbian.raspberrypi.org/raspbian buster/main armhf libisccc161 armhf 1:9.11.5.P4+dfsg-5.1+deb10u5
  404  Not Found [IP: 93.93.128.193 80]
Err:13 http://raspbian.raspberrypi.org/raspbian buster/main armhf libdns1104 armhf 1:9.11.5.P4+dfsg-5.1+deb10u5
  404  Not Found [IP: 93.93.128.193 80]
Err:14 http://raspbian.raspberrypi.org/raspbian buster/main armhf libisc1100 armhf 1:9.11.5.P4+dfsg-5.1+deb10u5
  404  Not Found [IP: 93.93.128.193 80]
Err:15 http://raspbian.raspberrypi.org/raspbian buster/main armhf liblwres161 armhf 1:9.11.5.P4+dfsg-5.1+deb10u5
  404  Not Found [IP: 93.93.128.193 80]
Err:16 https://dl.bintray.com/openhab/apt-repo2 stable/main armhf openhab all 3.0.2-1
  502  Bad Gateway [IP: 54.70.2.80 443]
Err:17 https://dl.bintray.com/openhab/apt-repo2 stable/main armhf openhab-addons all 3.0.2-1
  502  Bad Gateway [IP: 54.70.2.80 443]
E: Failed to fetch http://raspbian.raspberrypi.org/raspbian/pool/main/b/base-files/base-files_10.3+rpi1+deb10u10_armhf.deb  404  Not Found [IP: 93.93.128.193 80]
E: Failed to fetch http://raspbian.raspberrypi.org/raspbian/pool/main/k/krb5/libgssapi-krb5-2_1.17-3+deb10u2_armhf.deb  404  Not Found [IP: 93.93.128.193 80]
E: Failed to fetch http://raspbian.raspberrypi.org/raspbian/pool/main/k/krb5/libkrb5-3_1.17-3+deb10u2_armhf.deb  404  Not Found [IP: 93.93.128.193 80]
E: Failed to fetch http://raspbian.raspberrypi.org/raspbian/pool/main/k/krb5/libkrb5support0_1.17-3+deb10u2_armhf.deb  404  Not Found [IP: 93.93.128.193 80]
E: Failed to fetch http://raspbian.raspberrypi.org/raspbian/pool/main/k/krb5/libk5crypto3_1.17-3+deb10u2_armhf.deb  404  Not Found [IP: 93.93.128.193 80]
E: Failed to fetch http://raspbian.raspberrypi.org/raspbian/pool/main/t/tzdata/tzdata_2021a-0+deb10u1_all.deb  404  Not Found [IP: 93.93.128.193 80]
E: Failed to fetch http://raspbian.raspberrypi.org/raspbian/pool/main/b/bind9/libisc-export1100_9.11.5.P4+dfsg-5.1+deb10u5_armhf.deb  404  Not Found [IP: 93.93.128.193 80]
E: Failed to fetch http://raspbian.raspberrypi.org/raspbian/pool/main/b/bind9/libdns-export1104_9.11.5.P4+dfsg-5.1+deb10u5_armhf.deb  404  Not Found [IP: 93.93.128.193 80]
E: Failed to fetch http://raspbian.raspberrypi.org/raspbian/pool/main/b/bind9/bind9-host_9.11.5.P4+dfsg-5.1+deb10u5_armhf.deb  404  Not Found [IP: 93.93.128.193 80]
E: Failed to fetch http://raspbian.raspberrypi.org/raspbian/pool/main/b/bind9/libbind9-161_9.11.5.P4+dfsg-5.1+deb10u5_armhf.deb  404  Not Found [IP: 93.93.128.193 80]
E: Failed to fetch http://raspbian.raspberrypi.org/raspbian/pool/main/b/bind9/libisccfg163_9.11.5.P4+dfsg-5.1+deb10u5_armhf.deb  404  Not Found [IP: 93.93.128.193 80]
E: Failed to fetch http://raspbian.raspberrypi.org/raspbian/pool/main/b/bind9/libisccc161_9.11.5.P4+dfsg-5.1+deb10u5_armhf.deb  404  Not Found [IP: 93.93.128.193 80]
E: Failed to fetch http://raspbian.raspberrypi.org/raspbian/pool/main/b/bind9/libdns1104_9.11.5.P4+dfsg-5.1+deb10u5_armhf.deb  404  Not Found [IP: 93.93.128.193 80]
E: Failed to fetch http://raspbian.raspberrypi.org/raspbian/pool/main/b/bind9/libisc1100_9.11.5.P4+dfsg-5.1+deb10u5_armhf.deb  404  Not Found [IP: 93.93.128.193 80]
E: Failed to fetch http://raspbian.raspberrypi.org/raspbian/pool/main/b/bind9/liblwres161_9.11.5.P4+dfsg-5.1+deb10u5_armhf.deb  404  Not Found [IP: 93.93.128.193 80]
E: Failed to fetch https://dl.bintray.com/openhab/apt-repo2/pool/main/3.0.2/openhab_3.0.2-1_all.deb  502  Bad Gateway [IP: 54.70.2.80 443]
E: Failed to fetch https://dl.bintray.com/openhab/apt-repo2/pool/main/3.0.2/openhab-addons_3.0.2-1_all.deb  502  Bad Gateway [IP: 54.70.2.80 443]
E: Unable to fetch some archives, maybe run apt-get update or try with --fix-missing?
FAILED

so I tried apt-get update but receiving more errors

openhabian@openHABianDevice:~ $ sudo apt-get update
Get:1 http://archive.raspberrypi.org/debian buster InRelease [32.6 kB]
Get:2 http://raspbian.raspberrypi.org/raspbian buster InRelease [15.0 kB]
Hit:3 https://deb.nodesource.com/node_12.x buster InRelease
Hit:4 https://adoptopenjdk.jfrog.io/adoptopenjdk/deb buster InRelease
Err:5 https://dl.bintray.com/openhab/apt-repo2 stable InRelease
  502  Bad Gateway [IP: 52.39.229.247 443]
Reading package lists... Done
E: Repository 'http://archive.raspberrypi.org/debian buster InRelease' changed its 'Suite' value from 'testing' to 'oldstable'
N: This must be accepted explicitly before updates for this repository can be applied. See apt-secure(8) manpage for details.
E: Repository 'http://raspbian.raspberrypi.org/raspbian buster InRelease' changed its 'Suite' value from 'stable' to 'oldstable'
N: This must be accepted explicitly before updates for this repository can be applied. See apt-secure(8) manpage for details.

Seems my installation is looking to the wrong raspberry repositories?
Anyone having a good idea how to proceed?

Regards
Jan

Yes. It’s changed since 3.0

Thanks, rossko57.
Do I understand right that there is no chance to upgrade the system any more and I need to re-install it?

I had the same problems.

You need to do this

  • Add the repository key
wget -qO - 'https://openhab.jfrog.io/artifactory/api/gpg/key/public' | sudo apt-key add -
  • Add the HTTPS transport for APT
sudo apt-get install apt-transport-https
  • Add the repository
echo 'deb https://openhab.jfrog.io/artifactory/openhab-linuxpkg stable main' | sudo tee /etc/apt/sources.list.d/openhab.list

Then
apt-get update
apt-get upgrade

or run the openhabian config

hope this is of help.

Hi @JAFone ,
many thanks for your help. I followed your instructions. When using sudo apt-get update the last two entries changed the repository link and the errors are gone. But still getting complains about the first two repositories: Index of /debian buster InRelease and Index of /raspbian buster InRelease:

Get:1 http://archive.raspberrypi.org/debian buster InRelease [32.6 kB]
Get:2 http://raspbian.raspberrypi.org/raspbian buster InRelease [15.0 kB]
Hit:3 https://deb.nodesource.com/node_12.x buster InRelease
Hit:4 https://openhab.jfrog.io/artifactory/openhab-linuxpkg stable InRelease
Hit:5 https://adoptopenjdk.jfrog.io/adoptopenjdk/deb buster InRelease
Reading package lists... Done
E: Repository 'http://archive.raspberrypi.org/debian buster InRelease' changed its 'Suite' value from 'testing' to 'oldstable'
N: This must be accepted explicitly before updates for this repository can be applied. See apt-secure(8) manpage for details.
E: Repository 'http://raspbian.raspberrypi.org/raspbian buster InRelease' changed its 'Suite' value from 'stable' to 'oldstable'
N: This must be accepted explicitly before updates for this repository can be applied. See apt-secure(8) manpage for details.

Hence the sudo apt-get upgrade runs in similar error, not able to reach 93.93.128.193:

Reading package lists... Done
Building dependency tree
Reading state information... Done
Calculating upgrade... Done
The following packages have been kept back:
  adoptopenjdk-11-hotspot-jre
The following packages will be upgraded:
  alsa-utils base-files bind9-host bluez bluez-firmware ca-certificates device-tree-compiler file firmware-atheros
  firmware-brcm80211 firmware-libertas firmware-misc-nonfree firmware-realtek groff-base iproute2 iputils-ping isc-dhcp-client
  isc-dhcp-common klibc-utils libapt-inst2.0 libapt-pkg5.0 libasound2 libasound2-data libavahi-client3 libavahi-common-data
  libavahi-common3 libavahi-core7 libbind9-161 libbsd0 libc-bin libc-dev-bin libc-l10n libc6 libc6-dbg libc6-dev libcurl3-gnutls
  libdns-export1104 libdns1104 libgcrypt20 libgnutls30 libgssapi-krb5-2 libhogweed4 libisc-export1100 libisc1100 libisccc161
  libisccfg163 libk5crypto3 libklibc libkrb5-3 libkrb5support0 libldap-2.4-2 libldap-common libldb1 liblwres161 liblz4-1
  libmagic-mgc libmagic1 libnettle6 libnftnl11 libp11-kit0 libpam-systemd libpolkit-agent-1-0 libpolkit-backend-1-0
  libpolkit-gobject-1-0 libpython3.7 libpython3.7-dev libpython3.7-minimal libpython3.7-stdlib libraspberrypi-bin
  libraspberrypi-dev libraspberrypi-doc libraspberrypi0 libssl1.1 libsystemd0 libudev1 libuv1 libx11-6 libx11-data libxml2
  libzstd1 linux-libc-dev locales multiarch-support nodejs openhab openhab-addons openssh-client openssh-server
  openssh-sftp-server openssl pi-bluetooth policykit-1 python-dnspython python-ldb python-rpi.gpio python3.7 python3.7-dev
  python3.7-minimal raspberrypi-bootloader raspberrypi-kernel raspberrypi-net-mods raspberrypi-sys-mods rpi-eeprom rpi-update
  rpi.gpio-common ssh sudo systemd systemd-sysv tzdata udev wpasupplicant
112 upgraded, 0 newly installed, 0 to remove and 1 not upgraded.
Need to get 4,950 kB/635 MB of archives.
After this operation, 97.3 MB of additional disk space will be used.
Do you want to continue? [Y/n]
Err:1 http://raspbian.raspberrypi.org/raspbian buster/main armhf base-files armhf 10.3+rpi1+deb10u10
  404  Not Found [IP: 93.93.128.193 80]
Err:2 http://raspbian.raspberrypi.org/raspbian buster/main armhf libgssapi-krb5-2 armhf 1.17-3+deb10u2
  404  Not Found [IP: 93.93.128.193 80]
Err:3 http://raspbian.raspberrypi.org/raspbian buster/main armhf libkrb5-3 armhf 1.17-3+deb10u2
  404  Not Found [IP: 93.93.128.193 80]
Err:4 http://raspbian.raspberrypi.org/raspbian buster/main armhf libkrb5support0 armhf 1.17-3+deb10u2
  404  Not Found [IP: 93.93.128.193 80]
Err:5 http://raspbian.raspberrypi.org/raspbian buster/main armhf libk5crypto3 armhf 1.17-3+deb10u2
  404  Not Found [IP: 93.93.128.193 80]
Err:6 http://raspbian.raspberrypi.org/raspbian buster/main armhf tzdata all 2021a-0+deb10u1
  404  Not Found [IP: 93.93.128.193 80]
Err:7 http://raspbian.raspberrypi.org/raspbian buster/main armhf libisc-export1100 armhf 1:9.11.5.P4+dfsg-5.1+deb10u5
  404  Not Found [IP: 93.93.128.193 80]
Err:8 http://raspbian.raspberrypi.org/raspbian buster/main armhf libdns-export1104 armhf 1:9.11.5.P4+dfsg-5.1+deb10u5
  404  Not Found [IP: 93.93.128.193 80]
Err:9 http://raspbian.raspberrypi.org/raspbian buster/main armhf bind9-host armhf 1:9.11.5.P4+dfsg-5.1+deb10u5
  404  Not Found [IP: 93.93.128.193 80]
Err:10 http://raspbian.raspberrypi.org/raspbian buster/main armhf libbind9-161 armhf 1:9.11.5.P4+dfsg-5.1+deb10u5
  404  Not Found [IP: 93.93.128.193 80]
Err:11 http://raspbian.raspberrypi.org/raspbian buster/main armhf libisccfg163 armhf 1:9.11.5.P4+dfsg-5.1+deb10u5
  404  Not Found [IP: 93.93.128.193 80]
Err:12 http://raspbian.raspberrypi.org/raspbian buster/main armhf libisccc161 armhf 1:9.11.5.P4+dfsg-5.1+deb10u5
  404  Not Found [IP: 93.93.128.193 80]
Err:13 http://raspbian.raspberrypi.org/raspbian buster/main armhf libdns1104 armhf 1:9.11.5.P4+dfsg-5.1+deb10u5
  404  Not Found [IP: 93.93.128.193 80]
Err:14 http://raspbian.raspberrypi.org/raspbian buster/main armhf libisc1100 armhf 1:9.11.5.P4+dfsg-5.1+deb10u5
  404  Not Found [IP: 93.93.128.193 80]
Err:15 http://raspbian.raspberrypi.org/raspbian buster/main armhf liblwres161 armhf 1:9.11.5.P4+dfsg-5.1+deb10u5
  404  Not Found [IP: 93.93.128.193 80]
E: Failed to fetch http://raspbian.raspberrypi.org/raspbian/pool/main/b/base-files/base-files_10.3+rpi1+deb10u10_armhf.deb  404  Not Found [IP: 93.93.128.193 80]
E: Failed to fetch http://raspbian.raspberrypi.org/raspbian/pool/main/k/krb5/libgssapi-krb5-2_1.17-3+deb10u2_armhf.deb  404  Not Found [IP: 93.93.128.193 80]
E: Failed to fetch http://raspbian.raspberrypi.org/raspbian/pool/main/k/krb5/libkrb5-3_1.17-3+deb10u2_armhf.deb  404  Not Found [IP: 93.93.128.193 80]
E: Failed to fetch http://raspbian.raspberrypi.org/raspbian/pool/main/k/krb5/libkrb5support0_1.17-3+deb10u2_armhf.deb  404  Not Found [IP: 93.93.128.193 80]
E: Failed to fetch http://raspbian.raspberrypi.org/raspbian/pool/main/k/krb5/libk5crypto3_1.17-3+deb10u2_armhf.deb  404  Not Found [IP: 93.93.128.193 80]
E: Failed to fetch http://raspbian.raspberrypi.org/raspbian/pool/main/t/tzdata/tzdata_2021a-0+deb10u1_all.deb  404  Not Found [IP: 93.93.128.193 80]
E: Failed to fetch http://raspbian.raspberrypi.org/raspbian/pool/main/b/bind9/libisc-export1100_9.11.5.P4+dfsg-5.1+deb10u5_armhf.deb  404  Not Found [IP: 93.93.128.193 80]
E: Failed to fetch http://raspbian.raspberrypi.org/raspbian/pool/main/b/bind9/libdns-export1104_9.11.5.P4+dfsg-5.1+deb10u5_armhf.deb  404  Not Found [IP: 93.93.128.193 80]
E: Failed to fetch http://raspbian.raspberrypi.org/raspbian/pool/main/b/bind9/bind9-host_9.11.5.P4+dfsg-5.1+deb10u5_armhf.deb  404  Not Found [IP: 93.93.128.193 80]
E: Failed to fetch http://raspbian.raspberrypi.org/raspbian/pool/main/b/bind9/libbind9-161_9.11.5.P4+dfsg-5.1+deb10u5_armhf.deb  404  Not Found [IP: 93.93.128.193 80]
E: Failed to fetch http://raspbian.raspberrypi.org/raspbian/pool/main/b/bind9/libisccfg163_9.11.5.P4+dfsg-5.1+deb10u5_armhf.deb  404  Not Found [IP: 93.93.128.193 80]
E: Failed to fetch http://raspbian.raspberrypi.org/raspbian/pool/main/b/bind9/libisccc161_9.11.5.P4+dfsg-5.1+deb10u5_armhf.deb  404  Not Found [IP: 93.93.128.193 80]
E: Failed to fetch http://raspbian.raspberrypi.org/raspbian/pool/main/b/bind9/libdns1104_9.11.5.P4+dfsg-5.1+deb10u5_armhf.deb  404  Not Found [IP: 93.93.128.193 80]
E: Failed to fetch http://raspbian.raspberrypi.org/raspbian/pool/main/b/bind9/libisc1100_9.11.5.P4+dfsg-5.1+deb10u5_armhf.deb  404  Not Found [IP: 93.93.128.193 80]
E: Failed to fetch http://raspbian.raspberrypi.org/raspbian/pool/main/b/bind9/liblwres161_9.11.5.P4+dfsg-5.1+deb10u5_armhf.deb  404  Not Found [IP: 93.93.128.193 80]
E: Unable to fetch some archives, maybe run apt-get update or try with --fix-missing?

Is there maybe some command missing regarding the values from the two repositories?

E: Repository 'http://archive.raspberrypi.org/debian buster InRelease' changed its 'Suite' value from 'testing' to 'oldstable'
N: This must be accepted explicitly before updates for this repository can be applied. See apt-secure(8) manpage for details.
E: Repository 'http://raspbian.raspberrypi.org/raspbian buster InRelease' changed its 'Suite' value from 'stable' to 'oldstable'
N: This must be accepted explicitly before updates for this repository can be applied. See apt-secure(8) manpage for details.

Hi,
You might want to run this
apt-get update --allow-releaseinfo-change
apt-get update
apt-get upgrade --fix-missing

at the end i also did a
apt-get dist-upgrade

Then ran the openhabian-config and upgraded
My system is now at 3.2.0

//JAF

@JAFone many thanks, this worked for me!
I will try to summarize, for other persons facing same problem:

Problem
Updating Openhab 3 Version blw. 3.0.2 via upgrade fails with errors

Issue
Bintray service shut down on May 1st, 2021 → Links are not right any more

Solution

  1. Add the following repository key
wget -qO - 'https://openhab.jfrog.io/artifactory/api/gpg/key/public' | sudo apt-key add -
  1. Add the HTTPS transport for APT
sudo apt-get install apt-transport-https
  1. Add the repository
echo 'deb https://openhab.jfrog.io/artifactory/openhab-linuxpkg stable main' | sudo tee /etc/apt/sources.list.d/openhab.list
  1. Update, including allowing of release info change
sudo apt-get update --allow-releaseinfo-change
  1. Update (again)
sudo apt-get update
  1. Upgrade, incl. fix of missing
    You will be asked if some openhab files shall be overwritten by newer files. Check yourself, if you did manual changes. In my case, i didn’t had manual changes and took the new files.
sudo apt-get upgrade --fix-missing
  1. OPTIONAL Upgrade distribution
sudo apt-get dist-upgrade
  1. Run openhabian-config and upgrade system → 02 Upgrade System
    Seems to reconfigure AdoptOpenJDK 11
sudo openhabian-config

Best Regards
Jan

3 Likes

Especially made an account to thank you all! @JAFone summarization fixed the issue for me!
Also had to apply this fix in order to get everything working:

1 Like